/* yasep/ISM/ISM.js
 created lun. sept. 12 08:52:50 CEST 2011
 version dim. sept. 18 17:25:04 CEST 2011 : adding the ISM/presentation.js code
 version lun. sept. 19 08:45:47 CEST 2011 : translations OK

 This is a generic page loader for the /ISM/ directory, it also handle aliases.
 */

ISM={
  win: null,

  L:[
   ["Syntax examples :", "JavaScript properties of this opcode :"   ,"     Opcode number : ",'             Group : ', '             Forms : ','   With condition  ',
        '<p><b>*</b> Look at the <a href="#doc/mul">multiply page</a> for more informations on how to use this instruction.',
        '<p><b>*</b> This opcode is an <a href="#!doc/asm#asm_aliases">alias</a> to the <a class="opcode">', '</a> instruction.</p>',
        '<p><b>*</b> When using the "long immediate" form (<a href="#!doc/forms#IRR">IRR</a>), only the 5 least significant bits are used with YASEP32, and 4 bits with YASEP16.'
       +'<p><b>*</b> When using the "short immediate" form (<a href="#!doc/forms#iR">iR</a>),  only 4 bits (sign-extended) are available, be careful with YASEP32&nbsp;: use the long form for shifts between 8 to 23 positions.',
        '<p><b>*</b> When using the "long immediate" form (<a href="#!doc/forms#IRR">IRR</a>), only the 8 least significant bits are used.',
        '<p><b>*</b> This instruction is <a href="#!doc/flags#OPTIONAL">optional</a> and could be invalid, depending on the target core\'s implementation.</p>',
        '<p><b>*</b> This instruction is specific to <a href="#!doc/flags#YASEP32_ONLY">YASEP32</a> and has no meaning with a 16-bit version.</p>',
        '<p><b>*</b> This instruction is specific to <a href="#!doc/flags#YASEP16_ONLY">YASEP16</a> and has no meaning with a 32-bit version.</p>',
        '<p><b>*</b> You can play with this instruction in the <a href="#!tool/test_eu">Execution Unit simulator</a>.</p>\n',
        '       Description : ',
'then <tt><b>si4</b></tt> is written to<ul>'+
' <li> <tt><b>snd</b></tt> (short forms)'+
' <li> <tt><b>si4</b></tt> (long immediate form)'+
' <li> <tt><b>dst3</b></tt> (extended forms).</ul></p>',
        '<p><b>*</b> This instruction usually works by comparing the values (with a substraction) then conditionally aborting the write of <tt><b>si4</b></tt>. The long forms may not work in some versions of the core.</p>'
       +'<p><b>*</b> The <a class="opcode">SMAX</a> (Signed MAXimum), <a class="opcode">SMIN</a> (Signed MINimum), <a class="opcode">UMAX</a> (Unsigned MAXimum) and <a class="opcode">UMIN</a> (Unsigned MINimum) instructions are useful when clipping coordinates or sound samples, for example.</p>'+
'<pre class="instr">'+
'; Signed version :\n'+
' <a class="asm">SMAX R1 R2</a>       ; If R1&gt;R2    then R1->R2\n'+
' <a class="asm">SMAX 1234h R1 R2</a> ; If R1&gt;1234h then R1->R2 else 1234h->R2\n'+
' <a class="asm">SMIN R1 R2</a>       ; If R1&lt;R2    then R1->R2\n'+
' <a class="asm">SMIN 1234h R1 R2</a> ; If R1&lt;1234h then R1->R2 else 1234h->R2\n'+
'; Unsigned version :\n'+
' <a class="asm">UMAX R1 R2</a>       ; If R1&gt;R2    then R1->R2\n'+
' <a class="asm">UMAX 1234h R1 R2</a> ; If R1&gt;1234h then R1->R2 else 1234h->R2\n'+
' <a class="asm">UMIN R1 R2</a>       ; If R1&lt;R2    then R1->R2\n'+
' <a class="asm">UMIN 1234h R1 R2</a> ; If R1&lt;1234h then R1->R2 else 1234h->R2\n'+
'</pre>'
   ],
   ["Exemples de syntaxe :", "Propriétés JavaScript de cet opcode :","   Numéro d'opcode : ",'            Groupe : ', '            Formes : ','   Avec condition  ',
        '<p><b>*</b> Consultez la <a href="#doc/mul">page sur les multiplcations</a> pour de plus amples détails sur l\'utilisation de cet opcode.',
        '<p><b>*</b> Cet opcode est un <a href="#!doc/asm#asm_aliases">alias</a> vers l\'instruction <a class="opcode">', '</a>.</p>',
        '<p><b>*</b> Avec la forme "longue immédiate" (<a href="#!doc/forms#IRR">IRR</a>), seuls les 5 bits de poids faible sont pris en compte par YASEP32, et 4 bits avec YASEP16.'
       +'<p><b>*</b> Avec la forme "courte immediate" (<a href="#!doc/forms#iR">iR</a>),   seulement 4 bits sont disponibles (avec extension du signe), faites attention avec YASEP32&nbsp;: utilisez une forme longue pour les décalages de 8 à 23 bits)',
        '<p><b>*</b> Avec la forme "longue immédiate" (<a href="#!doc/forms#IRR">IRR</a>), seuls les 8 bits de poids faible sont pris en compte.',
        '<p><b>*</b> Cette instruction est <a href="#!doc/flags#OPTIONAL">optionnelle</a> et peut être invalide sur certains YASEP.</p>',
        '<p><b>*</b> Cette instruction est spécifique à <a href="#!doc/flags#YASEP32_ONLY">YASEP32</a> et n\'a aucun sens avec une version 16 bits.</p>',
        '<p><b>*</b> Cette instruction est spécifique à <a href="#!doc/flags#YASEP16_ONLY">YASEP16</a> et n\'a aucun sens avec une version 32 bits.</p>',
        '<p><b>*</b> Vous pouvez expérimenter avec cette opération dans le <a href="#!tool/test_eu">simulateur d\'unités d\'exécution</a>.</p>\n',
        '       Description : ',
'alors <tt><b>si4</b></tt> est écrit dans&nbsp;:<ul>'+
' <li> <tt><b>snd</b></tt> (formes courtes)'+
' <li> <tt><b>si4</b></tt> (forme immédiate longue)'+
' <li> <tt><b>dst3</b></tt> (formes étendues).</ul></p>',
        '<p><b>*</b> Cette instruction fonctionne en comparant les deux opérandes (avec une soustraction) puis, selon la retenue, en permettant l\'écriture de <tt><b>si4</b></tt>. C\'est plus complexe pour les formes longues donc elles risquent de ne pas fonctionner sur certaines version du YASEP.</p>'
       +'<p><b>*</b> Les instructions <a class="opcode">SMAX</a> (Signed MAXimum), <a class="opcode">SMIN</a> (Signed MINimum), <a class="opcode">UMAX</a> (Unsigned MAXimum) et <a class="opcode">UMIN</a> (Unsigned MINimum) sont utiles pour les calculs avec saturation par exemple (<i>clipping</i> de coordonnées graphiques ou d\'échantillons de son, par exemple).</p>'+
'<pre class="instr">'+
'; Version signée :\n'+
' <a class="asm">SMAX R1 R2</a>       ; Si R1&gt;R2    alors R1->R2\n'+
' <a class="asm">SMAX 1234h R1 R2</a> ; Si R1&gt;1234h alors R1->R2 sinon 1234h->R2\n'+
' <a class="asm">SMIN R1 R2</a>       ; Si R1&lt;R2    alors R1->R2\n'+
' <a class="asm">SMIN 1234h R1 R2</a> ; Si R1&lt;1234h alors R1->R2 sinon 1234h->R2\n'+
'; Version non signée :\n'+
' <a class="asm">UMAX R1 R2</a>       ; Si R1&gt;R2    alors R1->R2\n'+
' <a class="asm">UMAX 1234h R1 R2</a> ; Si R1&gt;1234h alors R1->R2 sinon 1234h->R2\n'+
' <a class="asm">UMIN R1 R2</a>       ; Si R1&lt;R2    alors R1->R2\n'+
' <a class="asm">UMIN 1234h R1 R2</a> ; Si R1&lt;1234h alors R1->R2 sinon 1234h->R2\n'+
'</pre>'
   ]
  ],

  start: function(target, orig_alias) {
    target=target.slice(4);
    orig_alias=orig_alias.slice(4); // remove "ISM/"
    var l=ISM.L[LANG.LANG];
    var cont=document.createElement("DIV");
    ISM.cont=cont;
    cont.innerHTML=import_htmi("ISM/"+orig_alias)+
'<p id="doc"></p>'+
'<h3>'+l[0]+'</h3>\n'+
'<pre id="example" class="instr">\n'+
'</pre>\n'+
'<h3>'+l[1]+'</h3>\n'+
'<pre id="dump">\n'+
'</pre>\n';

    ISM.win = ygwm.new_window(
       "Opcode "+orig_alias, null, cont,
       500, 400, 250, 250, false, true, true, true, false, "doc_yelo");

/* yasep/ISM/presentation.js
created 2007-03-28 by yann guidon
2007-11-05 : rebranding to YASEP
2009-07-09 : chaged before_load to addLoadEvent
2009-08-09
2009-08-23
*/

/* inclusion of yasep/ISM/dump_opcode_table.js
created 2007-03-28 by yann guidon
2007-04-01 : added the IR notice
2007-04-08
2007-04-16
2007-04-17 : allowing aliases
2007-11-05 : rebranding to YASEP
2007-11-07 : some healthy updates
2007-12-25 : changed the condition to display the link to test_eu.html
2007-11-?? : added support for FLAG_OPTIONAL|YASEP32_ONLY|YASEP16_ONLY
2007-11-30 : test_eu turned into test_eu16 and test_eu32
2008-12-27 : included in yasep/ISM/presentation.js as after_load to make it work under Opera
2009-01-08 : changed after_load to before_load
*/

  var x=getById('doc','p',cont);
  var y=getById('example','pre',cont);
  var z=getById('dump','pre',cont);
  var op=orig_alias;

  var s='';
  var u='';
  var m='';

  if (Y.table_opcode[op] != undefined) {
    if ((target=="UMIN")||(target=="UMAX")||(target=="SMIN")||(target=="SMAX")) {
      getById('minmax','span',cont).innerHTML=l[16];
      m+=l[17];
    }

    if (Y.opcode_aliases[target])
      m+=l[7]+Y.opcode_aliases[target]+l[8];

  /* display the properties */
    var o=Y.table_opcode[op];
        t=o.value,
        e=t & Y.FIELD_GROUP,
        f=o.forms,
        g=o.flags;

    s='            opcode : '+op+'\n'+l[2]+int2hex(t)+'\n';

    if (Y.GroupNames[e])
   s+=l[3]+Y.GroupNames[e].replace(/GROUP_/,'')+'\n';

    if (e == Y.GROUP_MUL)
      m+=l[6];

    if (g & Y.IMM16_5LSB)
      m+=l[9];

    if (g & Y.IMM16_8LSB)
      m+=l[10];

    if (e==Y.GROUP_ROP2)
      m+='<p><table border="1">'
        +'<tr><td>si4</td><td>snd</td><td></td><td><a href="#!ISM/AND">AND</a></td><td><a href="#!ISM/ANDN">ANDN</a></td>'
        +'<td><a href="#!ISM/NAND">NAND</a></td><td><a href="#!ISM/OR">OR</a></td><td><a href="#!ISM/ORN">ORN</a></td><td>'
        +'<a href="#!ISM/NOR">NOR</a></td><td><a href="#!ISM/XOR">XOR</a></td><td><a href="#!ISM/XORN">XORN</a></td></tr>'
        +'<tr><td>0</td><td>0</td><td></td><td>0</td><td>0</td><td>1</td><td>0</td><td>1</td><td>1</td><td>0</td><td>1</td></tr>'
        +'<tr><td>0</td><td>1</td><td></td><td>0</td><td>0</td><td>1</td><td>1</td><td>0</td><td>0</td><td>1</td><td>0</td></tr>'
        +'<tr><td>1</td><td>0</td><td></td><td>0</td><td>1</td><td>1</td><td>1</td><td>1</td><td>0</td><td>1</td><td>0</td></tr>'
        +'<tr><td>1</td><td>1</td><td></td><td>1</td><td>0</td><td>0</td><td>1</td><td>1</td><td>0</td><td>0</td><td>1</td></tr>'
        +'</table></p>';

//flags : OPTIONAL|YASEP32_ONLY|YASEP16_ONLY
    if (g & Y.OPTIONAL)
      m+=l[11];

    if (g & Y.YASEP32_ONLY)
      m+=l[12];

    if (g & Y.YASEP16_ONLY)
      m+=l[13];

    if ((typeof(Y.opcode_table[t].action32) == "function")
    ||  (typeof(Y.opcode_table[t].action16) == "function"))
      m+=l[14];

    if (o.description)
   s+=l[15]+o.description+'\n';
 
   s+=l[4]+Y.form2html(f)+'\n';

/* generate the examples */
    var i,j,k,n,fill='                ';
    for (i in Y.TableForm) {
      if (f & i) {
        j=Y.TableForm[i];
        k=j.replace(/FORM_/,'');

        n=Y.TableFormFunction[i](g);
        if (n!='')
          n=op+" "+n;
        else
          n=op;

        u+=' - <a href="#!doc/forms#'+k+'">'+j+'</a>'
          +fill.slice(j.length)+'<a class="asm">'+n+'</a>\n';
        if ((i & Y.FORMS_EXTENDABLE)&&((g & Y.NO_CONDITION)==0))
          u+=l[5]+'<a class="asm">'+n+' '+Y.randomCondition()+'</a>\n';
      }
    }

  /* the flags */
    if (g > 0) {
   s+='             Flags :'
      for (i in Y.TableFlags) {
        if (g & i) {
          s+=' <a href="#!doc/flags#'
              +Y.TableFlags[i].replace(/FLAG_/,'')+'">'
              +Y.TableFlags[i]+'</a>';
        }
      }
   s+='\n';
    }
  } // table_opcode[op]!=undefined

  x.innerHTML=m;
  y.innerHTML=u;
  z.innerHTML=s;

    winman.patchInnerLinks(cont);

    return ISM.win;
  }
}
